/*
 *  ACTIVATE.C (C) Copyright 1992 Aki Korhonen 
 *
 *      How to kill "Insert diskette for drive X:"
 *      Turbo C 2.0
 *
 *      main() function is a test driver for the
 *      activate_drive() function. On a single-drive
 *      system, create a file on the floppy drive named
 *      "TEST.FIL". With the disk in the drive, compile and
 *      run this program with ACTIVATE defined to 0 (plain way)
 *      and then to 1 (to use the activate_drive() function).
 */

#define ACTIVATE    1       /* make this 0 to test "plain" way */

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>   /* for intr()     */
#include <dir.h>   /* for fnsplit() */
#include <conio.h> /* for toupper()  */
#include <io.h>    /* for open()     */
#include <fcntl.h> /* for O_RDONLY   */
#include <ctype.h>

void activate_drive(char *pathname);

void main()
{
#if ACTIVATE
        /* Want to open a file? First make sure the drive is ok. */
  activate_drive("A:TEST.FIL");
#endif

  if (close(open("A:TEST.FIL", O_RDONLY)))
      exit(puts("Can't open A:TEST.FIL"));

#if ACTIVATE
        /* And again.  Look ma! No stinkeen dos messages! */
  activate_drive("B:TEST.FIL");
#endif

  if (close(open("B:TEST.FIL", O_RDONLY)))
      exit(puts("Can't open B:TEST.FIL"));
}
 
void activate_drive(char *pathname)
{
  struct REGPACK rp;
  char s1[4] , s2[70], s3[10], s4[6];

  fnsplit(pathname, s1,s2,s3,s4);   /* Split path into components */

  if (s1[0]) {                      /* drive named? if so, verify */
    rp.r_ax=0x440F;                 /* AX=440FH == Set Logical
                                       Drive Map, since DOS 3.2   */
    rp.r_bx=toupper(s1[0])-'A'+1;   /* BL=Drive # we want
                                       to use (A=1, B=2 ...)      */
    intr(0x21, &rp);                /* Make the DOS call          */
  }
}
