        .model medium
;***********************************************************************
;                             HUNSECS.ASM                             
;   HUNSECS [DECLARE FUNCTION HUNSECS& ()] is an assembled function for
; compiled BASIC programs.  HUNSECS reads the BIOS timer count directly
; (not using INT 1A so as not to reset the timer overflow flag), and
; returns the system time of day in hundredths of seconds as a long
; integer.  It serves the same timing purposes as does the intrinsic
; BASIC function "TIMER" without requiring floating-point arithmetic. 
;                Copyright (C) 1992 by Murray L. Lesser
;***********************************************************************

.code
        public  hunsecs
hunsecs proc
        push    bp              ;For safety's sake - no arguments passed
        mov     ax,40h          ;Timer count is dword at 40:6c
        mov     es,ax
        les     cx,es:[6ch]     ;Timer count now in ES:CX
        mov     ax,es           ;High word of timer count
        mov     bx,5            ;  (maximum value is 18h)
        mul     bx              ;Product still in AX, DX holds zero
        xchg    ax,cx           ;Low word of count now in AX
        mul     bx              ;  (high word of product in CX)
        add     dx,cx           ;Count * 5 * 65536 in DX:AX
        mov     bx,59659        ;1193180/20
        div     bx              ;Remainder in DX,
        mov     cx,ax           ;High word of quotient in CX
        xor     ax,ax
        div     bx              ;Low word of quotient in AX
        mov     dx,cx           ;Time of day in hundredths now in DX:AX
        pop     bp
        ret
hunsecs endp
        end
