;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                        ;
;          WINBOX.EXE written by Guy Eddon, 1992         ;
;                                                        ;
;    MASM 5.1:   MASM WINBOX.ASM;                        ;
;                LINK WINBOX;                            ;
;                                                        ;
;    MASM 6.0:   ML /Zm WINBOX.ASM                       ;
;                                                        ;
;    TASM:       tasm winbox                             ;
;                tlink winbox                            ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

assume cs:_TEXT,ds:_DATA,ss:STACK

_TEXT segment word public 'CODE'

Print proc far

       mov     ax,_DATA
       mov     ds,ax
       mov     ah,09h
       mov     dx,bx
       int     21h         ; DOS - Display string.
       retf

Print endp

Getch proc far

       mov     ax,0700h
       int     21h         ; DOS - Get key without echo.
       retf

Getch endp

Winbox proc far

Start:

       mov     ax,1600h
       int     2Fh         ; Win - Is enhanced mode running?
       jc      EnhancedModeNotRunning
       cmp     al,0
       je      EnhancedModeNotRunning
       cmp     al,80h
       je      EnhancedModeNotRunning
       jmp     EnhancedModeIsRunning

EnhancedModeNotRunning:

       mov     bx,offset m2
       call    Print
       jmp     Exiting

EnhancedModeIsRunning:

       mov     bx,offset m1
       call    Print
       mov     bx,offset m3
       call    Print
       mov     bx,offset m4
       call    Print
       call    Getch
       mov     bx,0015h    ; DOSMGR VxD.
       mov     ax,1684h
       int     2Fh         ; Win - Get API entry point in ES:DI.
       mov     ax,seg CriticalSection
       push    ax
       mov     ax,offset CriticalSection
       push    ax
       push    es
       push    di
       mov     ax,0001h
       retf                ; Returns to ES:DI, then to Critical.

CriticalSection:

       mov     ax,1681h
       int     2Fh         ; Win - Begin critical section.
       mov     bx,offset m5
       call    Print
       mov     bx,offset m9
       call    Print
       mov     bx,offset m6
       call    Print
       mov     bx,offset m4
       call    Print
       call    Getch
       mov     ax,1682h
       int     2Fh         ; Win - End critical section.
       mov     bx,offset m7
       call    Print
       mov     bx,offset m8
       call    Print

Exiting:

       mov     ax,4C00h
       int     21h         ; DOS - Exit with return code 0.

Winbox endp

_TEXT ends

_DATA segment word public 'DATA'

m1 db 0Dh,0Ah,'Windows is running in enhanced mode.', 0Ah,0Dh,'$'
m2 db 0Dh,0Ah,'Windows is not running in enhanced mode.', 0Ah,0Dh,'$'
m3 db 'WINBOX will now switch to full screen mode.', 0Ah,0Dh,'$'
m4 db 'Press any key to continue . . .', 0Ah,0Dh,0Ah,0Dh,'$'
m5 db 'WINBOX is now running full screen.', 0Ah,0Dh,'$'
m6 db 'Multitasking, Alt-Enter, and Alt-Tab are now unavailable.', 0Ah,0Dh,'$'
m7 db 'WINBOX has exited the critical section.', 0Ah,0Dh,'$'
m8 db 'Windows is now operational.', 0Ah,0Dh,'$'
m9 db 'WINBOX has entered a critical section.', 0Ah,0Dh,'$'

_DATA ends

STACK segment para stack 'STACK'

       db      128 dup (0)

STACK ends

end Start
